#!/usr/bin/python3

import sys
import os
import os.path as op
import getopt
import re

'''
#改
LOCAL_SRC_FILES	遇到的时候删除，最后添加
include $(*)	全部换为 include $(BUILD_PREBUILT)

#加
LOCAL_MODULE_PATH	所有类别都加，本来就是PREBUILT的除外
LOCAL_MODULE_OWNER	所有类别都加，若已有则不用再加
LOCAL_MODULE_TAGS	所有类别都加，若已有则不用再加
LOCAL_MODULE_CLASS	所有类别都加
LOCAL_MODULE_SUFFIX	所有类别都加，EXECUTABLES除外
LOCAL_MULTILIB		只有SHARED_LIBRARIES,STATIC_LIBRARIES添加

#SHARED_LIBRARIES, STATIC_LIBRARIES要考虑32位和64位的情况
Android.mk中本来的语句作为32位的使用，该加的加该修改的修改，后方紧跟着 include $(BUILD*) 语句用writemkfile再补充64位的语句
库文件的拷贝：以 模块名+32/64 作为目录名新建目录，将库文件拷贝至对应的目录下
'''

psrc_product_out = ''	# target的out目录 
psrc_qssi_out = '' #qssi的out目录 out/target/product/qssi


#wangdq
#需要单编才能生成的模块 make module
#libqmi_common_system 	


def rreplace(strings, old, new):
    position = strings.rfind(old)
    return (strings[:position] + strings[position:].replace(old, new))

# ------------------------------------------------------------------------------
# 拷贝源码编译出来的二进制文件
# psrc_product_out == pixel/LINUX/android/out/target/product/taro
# 无论如何介绍一下该函数的用法
def copyBinSrc(dstdir, module_type, module_name):
	#"""从源码目录out/target/product/taro(或qssi)目录里复制srcfile到dstdir目录"""
	if not op.isdir(dstdir): # 无论如何，先创建目标目录
		os.system('mkdir -p %s'%(dstdir))
	#二进制bin
	if module_type == 'EXECUTABLES':
		product_path = '%s/system/bin '%(psrc_product_out) + '%s/vendor/bin '%(psrc_product_out) +\
			'%s/product/bin '%(psrc_product_out) + '%s/system/product/bin '%(psrc_product_out)
		qssi_path = '%s/system/bin '%(psrc_qssi_out) + '%s/vendor/bin '%(psrc_qssi_out) +\
			'%s/product/bin '%(psrc_qssi_out) + '%s/system/product/bin '%(psrc_qssi_out) + '%s/system/system_ext/bin '%(psrc_qssi_out)
		os.system('find %s -name %s -execdir cp %s %s \\;'%(product_path,module_name,module_name,dstdir))
		if not op.isfile(dstdir + '/' + module_name):
			os.system('find %s -name %s -execdir cp %s %s \\;'%(qssi_path,module_name,module_name,dstdir))
			if not op.isfile(dstdir + '/' + module_name):
				return False
		return True

	#32位共享库，用于动态链接。类似动态库
	elif module_type == 'SHARED_LIBRARIES_32':
		product_path = '%s/obj_arm/SHARED_LIBRARIES '%(psrc_product_out) +\
			'%s/system/lib '%(psrc_product_out) + '%s/vendor/lib '%(psrc_product_out) +\
			'%s/product/lib '%(psrc_product_out) + '%s/system/product/lib '%(psrc_product_out)
		qssi_path = '%s/obj_arm/SHARED_LIBRARIES '%(psrc_qssi_out) +\
			'%s/system/lib '%(psrc_qssi_out) + '%s/vendor/lib '%(psrc_qssi_out) +\
			'%s/product/lib '%(psrc_qssi_out) + '%s/system/product/lib '%(psrc_qssi_out)
		os.system('find %s -name %s.so -execdir cp %s.so %s \\;'%(product_path,module_name,module_name,dstdir))
		if not op.isfile(dstdir + '/' + module_name + r'.so'):
			os.system('find %s -name %s.so -execdir cp %s.so %s \\;'%(qssi_path,module_name,module_name,dstdir))
			if not op.isfile(dstdir + '/' + module_name + r'.so'):
				return False
		return True
	#64位共享库，用于动态链接。类似动态库
	elif module_type == 'SHARED_LIBRARIES_64':
		product_path = '%s/obj/SHARED_LIBRARIES '%(psrc_product_out) +\
			'%s/system/lib64 '%(psrc_product_out) + '%s/vendor/lib64 '%(psrc_product_out) +\
			'%s/product/lib64 '%(psrc_product_out) + '%s/system/product/lib64 '%(psrc_product_out)
		qssi_path = '%s/obj/SHARED_LIBRARIES '%(psrc_qssi_out) +\
			'%s/system/lib64 '%(psrc_qssi_out) + '%s/vendor/lib64 '%(psrc_qssi_out) +\
			'%s/product/lib64 '%(psrc_qssi_out) + '%s/system/product/lib64 '%(psrc_qssi_out)
		os.system('find %s -name %s.so -execdir cp %s.so %s \\;'%(product_path,module_name,module_name,dstdir))
		if not op.isfile(dstdir + '/' + module_name + r'.so'):
			os.system('find %s -name %s.so -execdir cp %s.so %s \\;'%(qssi_path,module_name,module_name,dstdir))
			if not op.isfile(dstdir + '/' + module_name + r'.so'):
				return False
		return True
	#32静态库
	elif module_type == 'STATIC_LIBRARIES_32':
		product_path = '%s/obj_arm/STATIC_LIBRARIES/%s_intermediates/%s.a '%(psrc_product_out,module_name,module_name)
		qssi_path = '%s/obj_arm/STATIC_LIBRARIES/%s_intermediates/%s.a '%(psrc_qssi_out,module_name,module_name)
		os.system('find %s -name %s.a -execdir cp %s.a %s \\;'%(product_path,module_name,module_name,dstdir))
		if not op.isfile(dstdir + '/' + module_name + r'.a'):
			os.system('find %s -name %s.a -execdir cp %s.a %s \\;'%(qssi_path,module_name,module_name,dstdir))
			if not op.isfile(dstdir + '/' + module_name + r'.a'):
				return False
		return True
	#64位静态库
	elif module_type == 'STATIC_LIBRARIES_64':
		product_path = '%s/obj/STATIC_LIBRARIES/%s_intermediates/%s.a '%(psrc_product_out,module_name,module_name) +\
						'%s/obj/STATIC_LIBRARIES/%s_intermediates/%s.a '%(psrc_product_out,module_name,module_name)
		qssi_path = '%s/obj/STATIC_LIBRARIES/%s.cfi_intermediates/%s.a '%(psrc_qssi_out,module_name,module_name)
		os.system('find %s -name %s.a -execdir cp %s.a %s \\;'%(product_path,module_name,module_name,dstdir))
		if not op.isfile(dstdir + '/' + module_name + r'.a'):
			os.system('find %s -name %s.a -execdir cp %s.a %s \\;'%(qssi_path,module_name,module_name,dstdir))
			if not op.isfile(dstdir + '/' + module_name + r'.a'):
				os.system('find %s -name %s.cfi.a -execdir cp %s.cfi.a %s \\;'%(product_path,module_name,module_name,dstdir))
				if not op.isfile(dstdir + '/' + module_name + r'.cfi.a'):
					return False
		return True
	#java 库
	elif module_type == 'JAVA_LIBRARIES':
		product_path = '%s/obj/JAVA_LIBRARIES/%s_intermediates/javalib.jar '%(psrc_product_out,module_name) +\
			'%s/obj/PACKAGING/target_files_intermediates '%(psrc_product_out)
		qssi_path = '%s/obj/JAVA_LIBRARIES/%s_intermediates/javalib.jar '%(psrc_qssi_out,module_name) +\
			'%s/obj/PACKAGING/target_files_intermediates '%(psrc_qssi_out)
		os.system('find %s -name %s.jar -execdir cp %s.jar %s \\;'%(product_path,module_name,module_name,dstdir))
		os.system('find %s -name javalib.jar -execdir cp javalib.jar %s \\;'%(product_path,dstdir))
		if not op.isfile(dstdir + r'/javalib.jar') and not op.isfile(dstdir + r'/' + module_name + r'.jar'):
			os.system('find %s -name %s.jar -execdir cp %s.jar %s \\;'%(qssi_path,module_name,module_name,dstdir))
			os.system('find %s -name javalib.jar -execdir cp javalib.jar %s \\;'%(qssi_path,dstdir))
			if not op.isfile(dstdir + '/javalib.jar') and not op.isfile(dstdir + r'/' + module_name + r'.jar'):
				return False
		os.system('mv %s/javalib.jar %s/%s.jar'%(dstdir,dstdir,module_name))
		return True
	#java apk
	elif module_type == 'APPS':
		product_path = '%s/obj/APPS/%s_intermediates/package.apk '%(psrc_product_out,module_name) +\
			'%s/obj/PACKAGING/target_files_intermediates '%(psrc_product_out)
		qssi_path = '%s/obj/APPS/%s_intermediates/package.apk '%(psrc_qssi_out,module_name) +\
			'%s/obj/PACKAGING/target_files_intermediates '%(psrc_qssi_out)
		os.system('find %s -name %s.apk -execdir cp %s.apk %s \\;'%(product_path,module_name,module_name,dstdir))
		os.system('find %s -name package.apk -execdir cp package.apk %s \\;'%(product_path,dstdir))
		if not op.isfile(dstdir + r'/package.apk') and not op.isfile(dstdir + r'/' + module_name + r'.apk'):
			os.system('find %s -name %s.apk -execdir cp %s.apk %s \\;'%(qssi_path,module_name,module_name,dstdir))
			os.system('find %s -name package.apk -execdir cp package.apk %s \\;'%(qssi_path,dstdir))
			if not op.isfile(dstdir + '/package.apk') and not op.isfile(dstdir + r'/' + module_name + r'.apk'):
				return False
		os.system('mv %s/package.apk %s/%s.apk'%(dstdir,dstdir,module_name))
		return True


	return False


# def copyBinSrc(dstdir, module_type, module_name):
# 	return True
# ------------------------------------------------------------------------------
# 向新的mk中添加语句
def writeMakefile(VARS, makefile, module_type, copy_status):
	"""在makefile中按照VARS的值生成一个模块的Makefile"""
	makefile.write('LOCAL_MODULE_OWNER := ' + VARS['LOCAL_MODULE_OWNER'] + '\n')
	makefile.write('LOCAL_MODULE_TAGS := ' + VARS['LOCAL_MODULE_TAGS'] + '\n')
	makefile.write('LOCAL_MODULE_CLASS := ' + VARS['LOCAL_MODULE_CLASS'] + '\n')

	# 对于so来说这里只是64版本的地址
	if module_type != 'STATIC_LIBRARIES' and module_type != 'JAVA_LIBRARIES':
		makefile.write('LOCAL_MODULE_PATH := ' + VARS['LOCAL_MODULE_PATH'] + '\n')

	if module_type != 'EXECUTABLES' and VARS['LOCAL_MODULE_SUFFIX']:
		makefile.write('LOCAL_MODULE_SUFFIX := ' + VARS['LOCAL_MODULE_SUFFIX'] + '\n')

	# 对于 .so/.a 来说这里只是64版本的地址
	makefile.write('LOCAL_SRC_FILES := ' + VARS['LOCAL_SRC_FILES'] + '\n')

	if module_type == 'APPS':
		makefile.write('LOCAL_MODULE := ' + VARS['LOCAL_MODULE'] + '\n')

	if module_type == 'SHARED_LIBRARIES' or module_type == 'STATIC_LIBRARIES':
		makefile.write('LOCAL_MULTILIB := ' + VARS['LOCAL_MULTILIB'] + '\n') # 64bit
		if module_type == 'SHARED_LIBRARIES':
			makefile.write('LOCAL_STRIP_MODULE := ' + VARS['LOCAL_STRIP_MODULE'] + '\n')
		if copy_status == 2 or copy_status == 3: # 有64位版本
			makefile.write('include $(BUILD_PREBUILT)\n\n') # 64位结束
		VARS['LOCAL_MULTILIB'] = r'32'
		VARS['LOCAL_SRC_FILES'] = rreplace(VARS['LOCAL_SRC_FILES'], VARS['LOCAL_MODULE'] + r'64', VARS['LOCAL_MODULE'] + r'32')
		if module_type == 'SHARED_LIBRARIES':
			VARS['LOCAL_MODULE_PATH'] = rreplace(VARS['LOCAL_MODULE_PATH'], r'/lib64', r'/lib')
		else: # STATIC_LIBRARIES 没有 LOCAL_MODULE_PATH
			VARS['LOCAL_MODULE_PATH'] = ''
		if copy_status == 1 or copy_status == 3: # 有32位版本
			makefile.write('# do not include $(CLEAR_VARS)\n') # 不要轻易CLEAR_VARS，后面模块可能依赖这些变量
			for k,v in VARS.items():
				if v:
					makefile.write(k+' := '+v+'\n')
	if copy_status == 4 or copy_status == 3 or copy_status == 1:
		if module_type == 'HEADER_LIBRARY':
			makefile.write('include $(BUILD_HEADER_LIBRARY)\n\n')
		elif module_type == 'COPY_HEADERS':
			makefile.write('include $(BUILD_COPY_HEADERS)\n\n')
		elif module_type == 'HOST_PREBUILT':
			makefile.write('include $(BUILD_HOST_PREBUILT)\n\n')
		elif module_type == 'MULTI_PREBUILT':
			makefile.write('include $(BUILD_MULTI_PREBUILT)\n\n')
		elif module_type == 'PHONY_PACKAGE':
			makefile.write('include $(BUILD_PHONY_PACKAGE)\n\n')
		else:
			makefile.write('include $(BUILD_PREBUILT)\n\n')
	elif copy_status == 0:
		makefile.write('# do not include $(CLEAR_VARS)\n') # 不要轻易CLEAR_VARS，后面模块可能依赖这些变量
		for k in VARS: # 清空所有属性，避免对后续模块造成影响
			VARS[k] = ''
			VARS['LOCAL_MODULE_OWNER'] = r'qcom'
			VARS['LOCAL_MODULE_TAGS'] = r'optional'

# ------------------------------------------------------------------------------
def writeBp(clazz, props, bp):
	"""在makefile中按照VARS的值生成一个模块的Makefile"""
	bp.write('\n' + clazz + ' {\n')
	for k,v in props.items():
		if v and type(v) == str:
			bp.write('    ' + k + ': ' + v + '\n')
	if clazz != 'android_app_import':
		bp.write('''    strip: {
				none: ''' + props['strip']['none'] + ''',
				keep_symbols: ''' + props['strip']['keep_symbols'] + ''',
			},\n''')
	if clazz == 'cc_prebuilt_library_shared' or\
			clazz == 'cc_prebuilt_library_static':
		bp.write('''    multilib: {
				lib32: {
					srcs: ["''' + props['multilib']['lib32']['srcs'] + '''"],
				},
				lib64: {
					srcs: ["''' + props['multilib']['lib64']['srcs'] + '''"],
				},
			},\n''')
	bp.write('}\n') #写了一个结束符'}'
	bp.flush()

def getExportedHeadersDir(headers):
	"""Android.bp中定义的动态库需要导出头文件，因为引用该动态库的模块编译依赖于该动态库
	导出的头文件。这个时编译系统硬性规定的，即使实际的编译并不需要。
	本函数返回对应头文件的相对路径"""
	if not headers:
		return None
	print('ENV.prebuilt_Ihs path=%s headers=%s'%(ENV.prebuilt_Ihs, headers))
	cmdl = 'find %s -type d -name %s'%(ENV.prebuilt_Ihs, headers)
	result = os.popen(cmdl).read().strip()
	return op.relpath(op.join(op.realpath(result), 'gen'), op.dirname(ENV.prebuilt_Ihs))


#------------------------------------------------------------------------------
LOCAL_MODULE = re.compile(r'^LOCAL_MODULE[\s:]')
LOCAL_PACKAGE_NAME = re.compile(r'^LOCAL_PACKAGE_NAME[\s:]')
def isAndroidMKbuild(f, dir):
    VARS = {'LOCAL_MODULE','LOCAL_PACKAGE_NAME'}
    getval = lambda l: l.split('=')[-1].lstrip()
    with open(op.join(dir, f), 'r', encoding='Windows-1252') as mf: # Android.mk
        for line in mf:
            line = line.strip()
            if LOCAL_MODULE.match(line):
                #VARS['LOCAL_MODULE'] = getval(line)
                name = getval(line)
                index = build_package.find(name)
                if index >= 0:
                    print(name)
                    return True
                #print(name)
            elif LOCAL_PACKAGE_NAME.match(line):
                #VARS['LOCAL_PACKAGE_NAME'] = getval(line)
                name = getval(line)
                index = build_package.find(name)
                if index >= 0:
                    print(name)
                    return True
                            
        #mf.close()
    return False

# ------------------------------------------------------------------------------
CLEAR_VARS = re.compile(r'^include\s*\$\(CLEAR_VARS\)')
LOCAL_MODULE = re.compile(r'^LOCAL_MODULE[\s:]')
LOCAL_PACKAGE_NAME = re.compile(r'^LOCAL_PACKAGE_NAME[\s:]')
LOCAL_MODULE_OWNER = re.compile(r'^LOCAL_MODULE_OWNER[\s:]')
LOCAL_MODULE_CLASS = re.compile(r'^LOCAL_MODULE_CLASS[\s:]')
LOCAL_MODULE_TAGS = re.compile(r'^LOCAL_MODULE_TAGS[\s:]')
LOCAL_CERTIFICATE = re.compile(r'^LOCAL_CERTIFICATE[\s:]')
LOCAL_INSTALLED_MODULE_STEM = re.compile(r'^LOCAL_INSTALLED_MODULE_STEM[\s:]')
LOCAL_PRIVILEGED_MODULE = re.compile(r'^LOCAL_PRIVILEGED_MODULE[\s:]')
LOCAL_PROPRIETARY_MODULE = re.compile(r'^LOCAL_PROPRIETARY_MODULE[\s:]')
LOCAL_VENDOR_MODULE = re.compile(r'^LOCAL_VENDOR_MODULE[\s:]')
LOCAL_MODULE_RELATIVE_PATH = re.compile(r'^LOCAL_MODULE_RELATIVE_PATH[\s:]')
LOCAL_MODULE_PATH = re.compile(r'^LOCAL_MODULE_PATH[\s:]')
LOCAL_INIT_RC = re.compile(r'^LOCAL_INIT_RC[\s:]')
LOCAL_32_BIT_ONLY = re.compile(r'^LOCAL_32_BIT_ONLY[\s:]')
LOCAL_SRC_FILES = re.compile(r'^LOCAL_SRC_FILES[\s:]')
LOCAL_PRODUCT_MODULE = re.compile(r'^LOCAL_PRODUCT_MODULE[\s:]')

BUILD_EXECUTABLE = re.compile(r'^include\s*\$\(BUILD_EXECUTABLE\)')
BUILD_HOST_EXECUTABLE = re.compile(r'^include\s*\$\(BUILD_HOST_EXECUTABLE\)')
BUILD_SHARED_LIBRARY = re.compile(r'^include\s*\$\(BUILD_SHARED_LIBRARY\)')
BUILD_HOST_SHARED_LIBRARY = re.compile(r'^include\s*\$\(BUILD_HOST_SHARED_LIBRARY\)')
BUILD_STATIC_LIBRARY = re.compile(r'^include\s*\$\(BUILD_STATIC_LIBRARY\)')
BUILD_HOST_STATIC_LIBRARY = re.compile(r'^include\s*\$\(BUILD_HOST_STATIC_LIBRARY\)')
BUILD_RRO_PACKAGE = re.compile(r'^include\s*\$\(BUILD_RRO_PACKAGE\)')
BUILD_PHONY_PACKAGE = re.compile(r'^include\s*\$\(BUILD_PHONY_PACKAGE\)')
BUILD_PACKAGE = re.compile(r'^include\s*\$\(BUILD_PACKAGE\)')
BUILD_JAVA_LIBRARY = re.compile(r'^include\s*\$\(BUILD_JAVA_LIBRARY\)')
BUILD_STATIC_JAVA_LIBRARY = re.compile(r'^include\s*\$\(BUILD_STATIC_JAVA_LIBRARY\)')
BUILD_PREBUILT = re.compile(r'^include\s*\$\(BUILD_PREBUILT\)')
BUILD_HOST_PREBUILT = re.compile(r'^include\s*\$\(BUILD_HOST_PREBUILT\)')
BUILD_MULTI_PREBUILT = re.compile(r'^include\s*\$\(BUILD_MULTI_PREBUILT\)')
BUILD_HEADER_LIBRARY = re.compile(r'^include\s*\$\(BUILD_HEADER_LIBRARY\)')
BUILD_COPY_HEADERS = re.compile(r'^include\s*\$\(BUILD_COPY_HEADERS\)')

CAMX_BUILD_STATIC_LIBRARY = re.compile(r'^include\s*\$\(CAMX_BUILD_STATIC_LIBRARY\)')
CAMX_BUILD_SHARED_LIBRARY = re.compile(r'^include\s*\$\(CAMX_BUILD_SHARED_LIBRARY\)')
BUILD_NATIVE_TEST = re.compile(r'^include\s*\$\(BUILD_NATIVE_TEST\)')
BUILD_SYSTEM = re.compile(r'^include\s*\$\(BUILD_SYSTEM\)')

#For debug
BUILD_XXX = re.compile(r'^include\s*\$\(BUILD_')

#作用:
def parseAndroidMK(Android_mk, mk_dir, localpath = False):
	"""解析Android.mk，将解析到的模块在out目录下对于文件复制的到prebuilt_HY44，
	并在Android.mk生成Makefile"""
	VARS = {'LOCAL_MODULE': '',\
			'LOCAL_INIT_RC': '',\
			'LOCAL_MODULE_OWNER': r'qcom',\
			'LOCAL_INSTALLED_MODULE_STEM': '',\
			'LOCAL_MODULE_CLASS': '',\
			'LOCAL_MODULE_TAGS': r'optional',\
			'LOCAL_CERTIFICATE': '',\
			'LOCAL_MODULE_SUFFIX': '',\
			'LOCAL_UNINSTALLABLE_MODULE': '',\
			'LOCAL_PRIVILEGED_MODULE': '',\
			'LOCAL_PROPRIETARY_MODULE': '',\
			'LOCAL_VENDOR_MODULE': '',\
			'LOCAL_PRODUCT_MODULE': '',\
			'LOCAL_SRC_FILES': '',\
			'LOCAL_CLASSES_DEX_TOC': '',\
			'LOCAL_CLASSES_JACK': '',\
			'LOCAL_COPY_DST_DIR': '',\
			'LOCAL_MODULE_RELATIVE_PATH': '',\
			'LOCAL_MODULE_PATH': ''}

	getval = lambda l: l.split('=')[-1].lstrip()
	##
	# Some Android.mk are code in Windows-1252, open with UTF-8 or others may
	# cause an error
	##
	with open(op.join(mk_dir, Android_mk), 'r', encoding='Windows-1252') as mf: # Android.mk
		with open(op.join(mk_dir, 'newAndroid.mk'), 'w', encoding='Windows-1252') as mk: # new Android.mk
			for line in mf:
				skip = 'false' # 拷贝当前行到myAndroid.mk
				line = line.strip()
				if CLEAR_VARS.match(line):
					for k in VARS:
						VARS[k] = ''
						VARS['LOCAL_MODULE_OWNER'] = r'qcom'
						VARS['LOCAL_MODULE_TAGS'] = r'optional'
				elif LOCAL_MODULE.match(line):
					VARS['LOCAL_MODULE'] = getval(line)
				elif LOCAL_PACKAGE_NAME.match(line):
					VARS['LOCAL_PACKAGE_NAME'] = getval(line)
					skip = 'true'
				elif LOCAL_MODULE_OWNER.match(line):
					VARS['LOCAL_MODULE_OWNER'] = getval(line)
					skip = 'true'
				elif LOCAL_MODULE_CLASS.match(line):
					VARS['LOCAL_MODULE_CLASS'] = getval(line)
					skip = 'false' #这儿为什么要跳过，保留可否？
				elif LOCAL_MODULE_TAGS.match(line):
					VARS['LOCAL_MODULE_TAGS'] = getval(line)
					skip = 'true'
				elif LOCAL_CERTIFICATE.match(line):
					VARS['LOCAL_CERTIFICATE'] = getval(line)
				elif LOCAL_PROPRIETARY_MODULE.match(line):
					VARS['LOCAL_PROPRIETARY_MODULE'] = getval(line)
				elif LOCAL_PRIVILEGED_MODULE.match(line):
					VARS['LOCAL_PRIVILEGED_MODULE'] = getval(line)
				elif LOCAL_VENDOR_MODULE.match(line):
					VARS['LOCAL_VENDOR_MODULE'] = getval(line)
				elif LOCAL_PRODUCT_MODULE.match(line):
					VARS['LOCAL_PRODUCT_MODULE'] = getval(line)
				elif LOCAL_MODULE_RELATIVE_PATH.match(line):
					VARS['LOCAL_MODULE_RELATIVE_PATH'] = getval(line)
				elif LOCAL_INSTALLED_MODULE_STEM.match(line):
					VARS['LOCAL_INSTALLED_MODULE_STEM'] = getval(line)
				elif LOCAL_MODULE_PATH.match(line):
					VARS['LOCAL_MODULE_PATH'] = getval(line)
					skip = 'true'
				elif LOCAL_INIT_RC.match(line):
					VARS['LOCAL_INIT_RC'] = getval(line)
				elif LOCAL_SRC_FILES.match(line):
					VARS['LOCAL_SRC_FILES'] = getval(line) # 为BUILD_PREBUILT类型保存该值
					skip = 'true' # LOCAL_SRC_FILES遇到的时候不拷贝，最后根据实际情况添加

				elif BUILD_EXECUTABLE.match(line) or BUILD_NATIVE_TEST.match(line):
					skip = 'true' # 每个模块的最后一句都有一些需要添加或修改的内容，在此一起处理
					VARS['LOCAL_MODULE_CLASS'] = r'EXECUTABLES'
					dst = mk_dir # 将源码编译的二进制直接拷贝到当前目录下

					if VARS['LOCAL_PROPRIETARY_MODULE'] == 'true' or VARS['LOCAL_VENDOR_MODULE'] == 'true': # 高通私有模块，位于vendor
						VARS['LOCAL_MODULE_PATH'] = r'$(PRODUCT_OUT)/$(TARGET_COPY_OUT_VENDOR)/bin'

					elif VARS['LOCAL_PRODUCT_MODULE'] == 'true': # PRODUCT模块
						if args['--lunch'] == 'figure':
							VARS['LOCAL_MODULE_PATH'] = r'$(TARGET_PRODUCT_OUT_ROOT)/qssi/product/bin'
						elif args['--lunch'] == 'sdm845':
							VARS['LOCAL_MODULE_PATH'] = r'$(TARGET_PRODUCT_OUT_ROOT)/qssi/system/product/bin'

					else: # 一般模块，位于system
						VARS['LOCAL_MODULE_PATH'] = r'$(PRODUCT_OUT)/system/bin'

					if localpath:
						dst = op.join(dst, r'../../')

					if not copyBinSrc(dst, r'EXECUTABLES', VARS['LOCAL_MODULE']):
						copy_status = 0
						print('FAILED to copy ' + VARS['LOCAL_MODULE'] + ' to local directory') # 拷贝失败
					else:
						copy_status = 4
						VARS['LOCAL_SRC_FILES'] = VARS['LOCAL_MODULE'] # 已经拷贝到当前目录下
						writeMakefile(VARS, mk, 'EXECUTABLES', copy_status)

				elif BUILD_SHARED_LIBRARY.match(line) or CAMX_BUILD_SHARED_LIBRARY.match(line):
					VARS['LOCAL_MODULE_CLASS'] = r'SHARED_LIBRARIES'
					VARS['LOCAL_MODULE_SUFFIX'] = r'.so'
					skip = 'true' # 每个模块的最后一句都有一些需要添加或修改的内容，在此一起处理
					dst = mk_dir # 将源码编译的二进制直接拷贝到当前目录下

					if localpath:
						dst = op.join(dst, r'../../')

					if VARS['LOCAL_PROPRIETARY_MODULE'] == 'true' or VARS['LOCAL_VENDOR_MODULE'] == 'true' or\
						CAMX_BUILD_SHARED_LIBRARY.match(line):
						VARS['LOCAL_MODULE_PATH'] = r'$(PRODUCT_OUT)/$(TARGET_COPY_OUT_VENDOR)/lib'
						dst32 = dst + r'/' + VARS['LOCAL_MODULE'] + r'32/'

					elif VARS['LOCAL_PRODUCT_MODULE'] == 'true':
						if args['--lunch'] == 'figure':
							VARS['LOCAL_MODULE_PATH'] = r'$(TARGET_PRODUCT_OUT_ROOT)/qssi/product/lib'
						elif args['--lunch'] == 'sdm845':
							VARS['LOCAL_MODULE_PATH'] = r'$(TARGET_PRODUCT_OUT_ROOT)/qssi/system/product/lib'
						dst32 = dst + r'/' + VARS['LOCAL_MODULE'] + r'32/'

					else:
						#We don't need to care about 'system/lib[64]/hw'
						VARS['LOCAL_MODULE_PATH'] = r'$(PRODUCT_OUT)/system/lib'
						dst32 = dst + r'/' + VARS['LOCAL_MODULE'] + r'32/'

					module_name = VARS['LOCAL_MODULE']
					VARS['LOCAL_STRIP_MODULE'] = r'false'

					#32 BIT
					copy_status = 3
					if not copyBinSrc(dst32, r'SHARED_LIBRARIES_32', module_name):
						copy_status -= 1
						print('FAILED to copy ' + module_name + '.so to local directory') # 拷贝失败

					#64 BIT
					VARS['LOCAL_MULTILIB'] = r'64'
					dst64 = rreplace(dst32, r'32', r'64')
					VARS['LOCAL_MODULE_PATH'] = rreplace(VARS['LOCAL_MODULE_PATH'], r'/lib', r'/lib64')
					VARS['LOCAL_SRC_FILES'] = VARS['LOCAL_MODULE'] + r'64/' + module_name + r'.so'
					if not copyBinSrc(dst64, r'SHARED_LIBRARIES_64', module_name):
						copy_status -= 2
						print('FAILED to copy ' + module_name + '.so to local directory') # 拷贝失败
					writeMakefile(VARS, mk, 'SHARED_LIBRARIES', copy_status)
 
				elif BUILD_STATIC_LIBRARY.match(line) or CAMX_BUILD_STATIC_LIBRARY.match(line):
					VARS['LOCAL_MODULE_CLASS'] = r'STATIC_LIBRARIES'
					VARS['LOCAL_MODULE_SUFFIX'] = r'.a'
					skip = 'true' # 每个模块的最后一句都有一些需要添加或修改的内容，在此一起处理
					dst = mk_dir # 将源码编译的二进制直接拷贝到当前目录下

					if localpath:
						dst = op.join(dst, r'../../')

					#32 BIT
					dst32 = dst + r'/' + VARS['LOCAL_MODULE'] + r'32/'
					copy_status = 3
					if not copyBinSrc(dst32, r'STATIC_LIBRARIES_32', VARS['LOCAL_MODULE']):
						copy_status -= 1
						print('FAILED to copy ' + VARS['LOCAL_MODULE'] + '.a to local directory') # 拷贝失败

					#64 BIT
					VARS['LOCAL_MULTILIB'] = r'64'
					dst64 = rreplace(dst32, r'32', r'64')
					VARS['LOCAL_SRC_FILES'] = VARS['LOCAL_MODULE'] + r'64/' + VARS['LOCAL_MODULE'] + r'.a'
					if not copyBinSrc(dst64, r'STATIC_LIBRARIES_32', VARS['LOCAL_MODULE']):
						copy_status -= 2
						print('FAILED to copy ' + VARS['LOCAL_MODULE'] + '.a to local directory') # 拷贝失败
					writeMakefile(VARS, mk, 'STATIC_LIBRARIES', copy_status)

				elif BUILD_PACKAGE.match(line) or BUILD_RRO_PACKAGE.match(line):
					VARS['LOCAL_MODULE_CLASS'] = r'APPS'
					VARS['LOCAL_MODULE_SUFFIX'] = r'.apk'
					skip = 'true' # 每个模块的最后一句都有一些需要添加或修改的内容，在此一起处理
					dst = mk_dir # 将源码编译的二进制直接拷贝到当前目录下

					if localpath:
						dst = op.join(dst, r'../../')

					if not BUILD_RRO_PACKAGE.match(line):
						if VARS['LOCAL_PRODUCT_MODULE'] == 'true':
							if VARS['LOCAL_PRIVILEGED_MODULE'] == 'true':
								if args['--lunch'] == 'figure':
									VARS['LOCAL_MODULE_PATH'] = r'$(TARGET_PRODUCT_OUT_ROOT)/qssi/product/priv-app'
								elif args['--lunch'] == 'sdm845':
									VARS['LOCAL_MODULE_PATH'] = r'$(TARGET_PRODUCT_OUT_ROOT)/qssi/system/product/priv-app'
							else:
								if args['--lunch'] == 'figure':
									VARS['LOCAL_MODULE_PATH'] = r'$(TARGET_PRODUCT_OUT_ROOT)/qssi/product/app'
								elif args['--lunch'] == 'sdm845':
									VARS['LOCAL_MODULE_PATH'] = r'$(TARGET_PRODUCT_OUT_ROOT)/qssi/system/product/app'

						elif VARS['LOCAL_PROPRIETARY_MODULE'] == 'true' or VARS['LOCAL_VENDOR_MODULE'] == 'true':
							# src = 'vendor/app/'
							VARS['LOCAL_MODULE_PATH'] = r'$(PRODUCT_OUT)/$(TARGET_COPY_OUT_VENDOR)/app'

						elif VARS['LOCAL_PRIVILEGED_MODULE'] == 'true':
							# src = 'system/priv-app/'
							VARS['LOCAL_MODULE_PATH'] = r'$(PRODUCT_OUT)/system/priv-app'

						else:
							# src = 'system/app/'
							VARS['LOCAL_MODULE_PATH'] = r'$(PRODUCT_OUT)/system/app'

					else:
						VARS['LOCAL_MODULE_PATH'] = r'$(PRODUCT_OUT)/vendor/overlay'

					VARS['LOCAL_SRC_FILES'] = VARS['LOCAL_PACKAGE_NAME'] + r'.apk'
					VARS['LOCAL_MODULE'] = VARS['LOCAL_PACKAGE_NAME']
					VARS['LOCAL_PACKAGE_NAME'] = ''
					if copyBinSrc(dst, r'APPS', VARS['LOCAL_MODULE']):
						copy_status = 4
						writeMakefile(VARS, mk, 'APPS', copy_status)
					else:
						print('FAILED to copy ' + VARS['LOCAL_MODULE'] + '.apk to local directory') # 拷贝失败

				elif BUILD_JAVA_LIBRARY.match(line) or BUILD_STATIC_JAVA_LIBRARY.match(line):
					VARS['LOCAL_MODULE_CLASS'] = r'JAVA_LIBRARIES'
					VARS['LOCAL_MODULE_SUFFIX'] = r'$(COMMON_JAVA_PACKAGE_SUFFIX)'
					skip = 'true' # 每个模块的最后一句都有一些需要添加或修改的内容，在此一起处理
					dst = mk_dir # 将源码编译的二进制直接拷贝到当前目录下

					if localpath:
						dst = op.join(dst, r'../../')

					if BUILD_STATIC_JAVA_LIBRARY.match(line):
						VARS['LOCAL_UNINSTALLABLE_MODULE'] = 'true'

					if copyBinSrc(dst, r'JAVA_LIBRARIES', VARS['LOCAL_MODULE']):
						copy_status = 4
						VARS['LOCAL_SRC_FILES'] = VARS['LOCAL_MODULE'] + r'.jar'
						writeMakefile(VARS, mk, 'JAVA_LIBRARIES', copy_status)
					else:
						print('FAILED to copy ' + VARS['LOCAL_MODULE'] + '.jar to local directory') # 拷贝失败

				elif BUILD_PREBUILT.match(line):
					skip = 'true' # 每个模块的最后一句都有一些需要添加或修改的内容，在此一起处理
					copy_status = 4
					writeMakefile(VARS, mk, 'PREBUILT', copy_status)

				elif BUILD_HOST_PREBUILT.match(line):
					skip = 'true' # 每个模块的最后一句都有一些需要添加或修改的内容，在此一起处理
					copy_status = 4
					writeMakefile(VARS, mk, 'HOST_PREBUILT', copy_status)

				elif BUILD_MULTI_PREBUILT.match(line):
					skip = 'true' # 每个模块的最后一句都有一些需要添加或修改的内容，在此一起处理
					copy_status = 4
					writeMakefile(VARS, mk, 'MULTI_PREBUILT', copy_status)

				elif BUILD_HEADER_LIBRARY.match(line):
					skip = 'true' # 每个模块的最后一句都有一些需要添加或修改的内容，在此一起处理
					copy_status = 4
					writeMakefile(VARS, mk, 'HEADER_LIBRARY', copy_status)

				elif BUILD_COPY_HEADERS.match(line):
					skip = 'true' # 每个模块的最后一句都有一些需要添加或修改的内容，在此一起处理
					copy_status = 4
					writeMakefile(VARS, mk, 'COPY_HEADERS', copy_status)

				elif BUILD_PHONY_PACKAGE.match(line):
					skip = 'true'
					copy_status = 4
					writeMakefile(VARS, mk, 'PHONY_PACKAGE', copy_status)

				elif BUILD_SYSTEM.match(line): # include $(BUILD_SYSTEM) ???
					skip = 'false'

				elif BUILD_HOST_SHARED_LIBRARY.match(line) or BUILD_HOST_STATIC_LIBRARY.match(line) or \
					BUILD_HOST_EXECUTABLE.match(line): # 丢弃
					skip = 'true'

				elif BUILD_XXX.match(line):
					skip = 'false'
					#print('debug:'+line)
					print('NOT supported build type:')
					print(VARS)

				if skip == 'false': # 一般语句全部拷贝，特殊语句对应处理
					mk.write(line + '\n')
				continue


#----------------------------
def isAndroidBPbuild(f, bp_dir):
    begin = lambda l: l.split(':')[0].strip() #begin(line) vendor:true  --这儿返回vendor #split()当不带参数时以空格进行分割，当代参数时，以该参数进行分割。
    getrstr = lambda l: l.split(':')[-1].strip() #getrstr(line) vendor:true 这儿返回就是true
    getval = lambda s: s.rstrip(',').lstrip('"').rstrip('"').strip(',') #rstrip删除string字符串末尾的指定字符；lstrip：用于截掉字符串左边的空格或指定字符。

    with open(op.join(bp_dir, 'Android.bp'), 'r') as bp:
        for line in bp:
            line_no_strip = line.rstrip()
            line = line.strip()
            
            if begin(line) == 'name':
                #print(line)#   name: "libsoc_helper",
                name = getrstr(line) # "libsoc_helper",
                #print('%s'%(name))
                name = getval(name) # libsoc_helper
                #print('%s'%(name))
                index = build_package.find(name)
                #print("index=%s"%(index))
                if index >= 0:
                    #print("finded")
                    return True
                #在build_package查找name，

        bp.close()
    
    return False

# ------------------------------------------------------------------------------
hidl_interface = re.compile(r'^hidl_interface[\s{]') # 全部照抄
cc_library_headers = re.compile(r'^cc_library_headers[\s{]') # 全部照抄
hidl_package_root = re.compile(r'^hidl_package_root[\s{]') # 全部照抄
cc_test = re.compile(r'^cc_test[\s{]') # 删除
bootstrap_go_package = re.compile(r'^bootstrap_go_package[\s{]') # 全部照抄 #wangdq-这个应该被淘汰了
perfHaldefaults = re.compile(r'^perfHaldefaults[\s{]') # 全部照抄 #wangdq-这个应该被淘汰了
# 由于Android.bp中没有预编译java库的模块类型，结合865+AndroidQ的当前实际情况，先删除
java_library = re.compile(r'^java_library[\s{]') # 保留源码方式
java_library_static = re.compile(r'^java_library_static[\s{]') # 保留源码方式
prebuilt_etc = re.compile(r'^prebuilt_etc[\s{]') # 全部照抄
cc_library_shared = re.compile(r'^cc_library_shared[\s{]')
cc_library_static = re.compile(r'^cc_library_static[\s{]')
cc_binary = re.compile(r'^cc_binary[\s{]')

android_app = re.compile(r'^android_app[\s{]') # wangdq
cc_library = re.compile(r'^cc_library[\s{]') # 全部照抄 wangdq
filegroup = re.compile(r'^filegroup[\s{]') # 全部照抄 wangdq
sh_binary = re.compile(r'^sh_binary[\s{]') # 全部照抄 wangdq
prebuilt_firmware = re.compile(r'^prebuilt_firmware[\s{]') # 全部照抄 wangdq
prebuilt_etc_host = re.compile(r'^prebuilt_etc_host[\s{]') # 全部照抄 wangdq
cc_defaults = re.compile(r'^cc_defaults[\s{]') # 全部照抄 wangdq
common_cflags = re.compile(r'^common_cflags[\s{]') # 全部照抄 wangdq
soong_config_module_type = re.compile(r'^soong_config_module_type[\s{]') # 全部照抄 wangdq
genrule = re.compile(r'^genrule[\s{]') # 全部照抄 wangdq
filegroup = re.compile(r'^filegroup[\s{]') # 全部照抄 wangdq
cc_binary_host = re.compile(r'^cc_binary_host[\s{]') # 全部照抄 wangdq
export_header_lib_headers = re.compile(r'^export_header_lib_headers[\s{]') # wangdq 该类型也必须要保留

module_end = re.compile(r'^}$') #以'}'作为一个module的结束标志

#init_rc  #wangdq 还需要加这些字段
#vintf_fragments #wangdq 还需要加这些字段
# static_libs header_libs  shared_libs #wangdq 还需要加这些字段
# xxx_defaul字段
#可以再做一个正则表达式能够读"{},", "[],""括号换行的表达式  #wangdq
#xxx: {
#},
#xxx: [
#]

def parse_one_module(line):
	if copy == 'true':
		print('line_no_strip_last=%s'%(line_no_strip)) #看出写入Android.bp的内容是什么
		bp.write(line_no_strip + '\n')

#解析模块的时候，需要判断哪些模块加入了PRODUCT_PACKAGES变量:PRODUCT_PACKAGES += libsll 加入了的。才能输出
def parseAndroidBP(bp, bp_dir):
	"""解析Android.bp，将对应的模块在out目录下对应文件复制到prebuilt_HY44，
	并在Android.bp中生存对应的Makefile"""
	props = {
			'name': '',\
			'stem': '',\
			'suffix': '',\
			'owner': '',\
			'init_rc': '',\
			'vendor': '',\
			'vendor_available': '',\
			'product_specific': '',\
			'relative_install_path': '',\
			'host_supported': '',\
			'proprietary': '',\
			'certificate': '',\
			'defaults': '',\
			'installable': '',\
			'pack_relocations': '',\
			'clang': '',\
			'shared_libs': '',\
			'export_include_dirs': '',\
			'system_ext_specific': '',\
			'srcs': '',\
			'compile_multilib': '',\
			'multilib': {'lib32': {'srcs': ''}, 'lib64': {'srcs': ''}},\
			'strip': {'none': 'true', 'keep_symbols': 'true'},\
			}
	clazz = ''
	begin = lambda l: l.split(':')[0].strip() #begin(line) vendor:true  --这儿返回vendor #split()当不带参数时以空格进行分割，当代参数时，以该参数进行分割。
	getrstr = lambda l: l.split(':')[-1].strip() #getrstr(line) vendor:true 这儿返回就是true
	getval = lambda s: s.rstrip(',').lstrip('[').rstrip(']').strip('"') #rstrip删除string字符串末尾的指定字符；lstrip：用于截掉字符串左边的空格或指定字符。
	with open(op.join(bp_dir, bp), 'r') as f:
		with open(op.join(bp_dir, 'newAndroid.bp'), 'w') as bp:
			copy = 'ture' #需要处理的特殊模块之外的模块原封不动拷贝(同一个文件)
			export_generated_headers = ''
			for line in f:
				print('line=%s'%(line))
				#FIXME:Should consider the comments
				line_no_strip = line.rstrip() # 否则会出现左对齐的现象(rstrip函数返回字符串副本，该副本是从字符串最右边删除了参数指定字符后的字符串，不带参数进去则是去除最右边的空格)
				line = line.strip() #
				if hidl_interface.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str: #如果类型为字符串，则置空
							props[k] = ''
					clazz = 'hidl_interface'
				elif cc_library_headers.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = '' #置空的目的，是在下面判断clazz的时候写
					clazz = 'cc_library_headers'
				elif hidl_package_root.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'hidl_package_root'
				elif bootstrap_go_package.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'bootstrap_go_package'
				elif android_app.match(line): #wangdq 这儿需要修改，不应该照抄
					copy = 'false'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'android_app_import'			
				elif perfHaldefaults.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'perfHaldefaults'
				elif prebuilt_etc.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'prebuilt_etc'
				elif genrule.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'genrule'
				elif filegroup.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'filegroup'
				elif soong_config_module_type.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'soong_config_module_type'
				elif prebuilt_etc_host.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'prebuilt_etc_host'
				elif cc_binary_host.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'cc_binary_host'
				elif cc_defaults.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'cc_defaults'
				elif common_cflags.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'common_cflags'
				elif sh_binary.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'sh_binary'
#				elif shared_libs.match(line): # 照抄
#					copy = 'true'
#					export_generated_headers = ''
#					for k in props:
#						if type(props[k]) == str:
#							props[k] = ''
#					clazz = 'shared_libs'
				elif prebuilt_firmware.match(line): # 照抄
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'prebuilt_firmware'
				elif cc_test.match(line): # 删除
					copy = 'false'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'cc_test'
				elif cc_library_shared.match(line):
					copy = 'false'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'cc_prebuilt_library_shared'
				elif cc_library.match(line):
					copy = 'false'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'cc_prebuilt_library_shared'
				elif cc_library_static.match(line):
					copy = 'false'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'cc_prebuilt_library_static'
				elif java_library.match(line) or java_library_static.match(line):
					copy = 'true'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'not_recognized_class'
				elif cc_binary.match(line):
					copy = 'false'
					export_generated_headers = ''
					for k in props:
						if type(props[k]) == str:
							props[k] = ''
					clazz = 'cc_prebuilt_binary'
				elif begin(line) == 'name':
					props['name'] = getrstr(line)
				elif begin(line) == 'stem':
					props['stem'] = getrstr(line)
				elif begin(line) == 'suffix':
					props['suffix'] = getrstr(line)
				elif begin(line) == 'init_rc':
					props['init_rc'] = getrstr(line)
				elif begin(line) == 'owner':
					props['owner'] = getrstr(line)
				elif begin(line) == 'vendor':
					if getrstr(line) == '{':
						props['vendor'] = ''
					else:
						props['vendor'] = getrstr(line)
					#这儿特殊处理一下，如果是'vendor: {' 这种的，则置为空
				elif begin(line) == 'vendor_available':
					props['vendor_available'] = getrstr(line)
				elif begin(line) == 'product_specific':
					props['product_specific'] = getrstr(line)
				elif begin(line) == 'relative_install_path':
					props['relative_install_path'] = getrstr(line)
				elif begin(line) == 'proprietary':
					props['proprietary'] = getrstr(line)
				elif begin(line) == 'certificate':
					props['certificate'] = getrstr(line)
				elif begin(line) == 'installable':
					props['installable'] = getrstr(line)
				elif begin(line) == 'host_supported':	#这个变量很重要。设置为 true 时，可将生成的库提供给主机环境。
    					props['host_supported'] = getrstr(line)
				elif begin(line) == 'pack_relocations':
    					props['pack_relocations'] = getrstr(line)
				elif begin(line) == 'clang':
					props['clang'] = getrstr(line)
				elif begin(line) == 'export_generated_headers':  #wangdq add 这儿执行有错
					export_generated_headers = getrstr(line)
					print('wangdqif line=%s'%(line))
					print('wangdqif export_generated_headers=%s'%(export_generated_headers))
					#FIXME:Need a better way to locate the end of a module
				elif module_end.match(line_no_strip):# should use "line_no_strip" here 这儿匹配是:"}"
					if not props['name'] or not clazz:  #这儿暂时注释掉。因为当props['name'] 或者clazz有值时，结束花括号就没有写入。不知道为什么？
						clazz = ''
						print('name1=%s'%(props['name']))
						continue #丢掉
					name = getval(props['name'])
					initrc = getval(props['init_rc'])
					dst = bp_dir # 将源码编译的二进制直接拷贝到当前目录下
					if export_generated_headers:
						headers = getval(export_generated_headers)
						print('----headers=%s'%(headers))
						#props['export_include_dirs'] = '["' + getExportedHeadersDir(headers) + '"],'

					if clazz == 'cc_prebuilt_library_shared':
						props['srcs'] = ''
						# vendor/lib[64]
						if 'true' in props['vendor'] or 'true' in props['proprietary']:
							dst32 = dst + r'/' + name + r'_32/'
							#if initrc:
							#	rcdst = r'vendor/etc/init/'
							#	props['init_rc'] = r'vendor/etc/init/' + initrc
						else:
							dst32 = dst + r'/' + name + r'_32/'
							#if initrc:
							#	rcdst = r'system/etc/init/'
							#	props['init_rc'] = r'system/etc/init/' + initrc
						if props['relative_install_path']:
							dst32 = dst + r'/' + name + r'_32/'

						# 32bit #copyBinSrc 拷贝各种库到当前bp目录下
						if not copyBinSrc(dst32, r'SHARED_LIBRARIES_32', name):
							print('FAILED to copy ' + name + '.so to local directory') # 拷贝失败
						props['multilib']['lib32']['srcs'] = name + r'_32/' + name + r'.so'

						# 64bit
						dst64 = dst + r'/' + name + r'_64/'
						if not copyBinSrc(dst64, r'SHARED_LIBRARIES_64', name):
							print('FAILED to copy ' + name + '.so to local directory') # 拷贝失败
						props['multilib']['lib64']['srcs'] = name + r'_64/' + name + r'.so'
						writeBp(clazz, props, bp)

					elif clazz == 'cc_prebuilt_library_static': # 静态库，目前只有一个模块
						props['srcs'] = ''
						dst32 = dst + r'/' + name + r'_32/'
						dst64 = dst + r'/' + name + r'_64/'

						# 32bit
						if not copyBinSrc(dst32, r'STATIC_LIBRARIES_32', name):
							print('FAILED to copy ' + name + '.a to local directory') # 拷贝失败
						props['multilib']['lib32']['srcs'] = name + r'_32/' + name + r'.a'

						# 64bit
						if not copyBinSrc(dst64, r'STATIC_LIBRARIES_64', name):
							print('FAILED to copy ' + name + '.a to local directory') # 拷贝失败
						props['multilib']['lib64']['srcs'] = name + r'_64/' + name + r'.a'
						writeBp(clazz, props, bp)#wangdq 如果没有找到对应的.so或者.a。但是规则写了。也会报错。

					elif clazz == 'prebuilt_java_library': # java库
						props['srcs'] = ''
						if not copyBinSrc(dst, r'JAVA_LIBRARIES', name):
							print('FAILED to copy ' + name + '.jar to local directory') # 拷贝失败
						else:
							os.system('mv %s/javalib.jar %s/%s'%(bp_dir, bp_dir, name + r'.jar'))
						props['srcs'] = '["' + name + r'.jar' + '"],'
						writeBp(clazz, props, bp)

					elif clazz == 'cc_prebuilt_binary': # 二进制 #wangdq 二进制还需要分32/64位
						if not copyBinSrc(dst, r'EXECUTABLES', name):
							print('FAILED to copy ' + name + ' to local directory') # 拷贝失败，打印信息记录对应的二进制文件
						props['srcs'] = '["' + name + '"],' # 二进制文件已经拷贝到当前目录下
						writeBp(clazz, props, bp)

					elif clazz == 'android_app_import': # wangdq Android APP	
						if not copyBinSrc(dst, r'APPS', name):
							print('FAILED to copy ' + name + ' to local directory') # 拷贝失败，打印信息记录对应的二进制文件
						#props['srcs'] = '["' + name + '"],' # android app 文件已经拷贝到当前目录下
						props['apk'] = '"' + name + '.apk",'
						writeBp(clazz, props, bp)
					
					clazz = ''
				
				if copy == 'true':
					print('line_no_strip_last=%s'%(line_no_strip)) #看出写入Android.bp的内容是什么
					bp.write(line_no_strip + '\n')

# ------------------------------------------------------------------------------
def printUsage():
	print("使用方法：")
	print(('./tool.py --lunch=taro(编译时的lunch选项) --srcdir=/home/somebody/projects/pixel(项目代码根目录) '
		'--sdkdir=/home/somebody/projects/pixel_sdk(SDK将要存放的目录) --copy=y/n --cmpcpy=n/y'))

# ------------------------------------------------------------------------------
def getCmdArgs(argv):
	print(argv)
	if argv[1] in ('--help', 'help', '-h', 'h'):
		printUsage()
		sys.exit(0)
	myargs = {'--lunch': '',\
		  '--srcdir': '',\
		  '--sdkdir': '',\
		  '--copy': '',\
		  '--cmpcpy': ''\
		 }
	try:
		opts, args = getopt.getopt(argv[1:], "h",\
				["lunch=", "srcdir=", "sdkdir=", "copy=", "cmpcpy="])
	except getopt.GetoptError as err:
		print(err)
		printUsage()
		sys.exit(2)
	for k,v in opts:
		myargs[k] = v
	print(myargs)
	for k,v in myargs.items():
		if not v:
			print('ERROR: %s 未指定'%(k))
			printUsage()
			sys.exit(2)
	if myargs['--copy'] == 'y' and myargs['--cmpcpy'] == 'y'\
		or myargs['--copy'] == 'n' and myargs['--cmpcpy'] == 'n':
		print('ERROR: --copy --cmpcpy　不能指定为相同值')
		printUsage()
		sys.exit(2)
	return myargs

# ------------------------------------------------------------------------------
# "main"
args = getCmdArgs(sys.argv)
psrc_ap = op.join(args['--srcdir'], 'LINUX/android')  #--srcdir /home/wangdq/8450/vendor/LA.VENDOR.1.0
psrc_product_out = op.join(args['--srcdir'], 'LINUX/android/out/target/product', args['--lunch'])
psrc_qssi_out = op.join(args['--srcdir'], 'LINUX/android/out/target/product/qssi')
# psrc_ap = op.join(args['--srcdir'])  #--srcdir /home/wangdq/8450/vendor/LA.VENDOR.1.0
# psrc_product_out = op.join(args['--srcdir'], 'out/target/product', args['--lunch'])
# psrc_qssi_out = op.join(args['--srcdir'], 'out/target/product/qssi') # wangdq  这个是我自己加的。s平台out目录是没有qssi目录。我从qssi工程下拷过来的。
is_in_target = True
psdk = args['--sdkdir']
psdk_vendor_proprietary = op.join(args['--sdkdir'], 'vendor/qcom/proprietary') #--sdkdir ~/8450/vendor/LA.VENDOR.1.0/LINUX/android/turbox_sdk
psdk_product_out = op.join(args['--sdkdir'], 'out/target/product', args['--lunch'])
psdk_qssi_out = op.join(args['--sdkdir'], 'out/target/product/qssi')
psdk_complete_product_out = op.join(psdk_vendor_proprietary, 'complete_out', args['--lunch']) # vendor/qcom/proprietary/complete_out
psdk_complete_qssi_out = op.join(psdk_vendor_proprietary, 'complete_out/qssi')# vendor/qcom/proprietary/complete_out/qssi
proprietary_whitelist = ('')

with open('PRODUCT_PACKAGES.txt', 'r') as txt:
	build_package = txt.readline()
	#build_package = line.split()
	txt.close()

#techpack/artifacts/camera/里面本来就是库。不需要修改规则
# vendor/qcom/proprietary 下部分目录可释放
if args['--lunch'] == 'figure' or args['--lunch'] == 'sdm710':
	proprietary_whitelist = ('common/', 'prebuilt_HY11/', 'llvm-arm-toolchain-ship/',\
			'commonsys-intf/telephony/interfaces/', 'nqnfc-firmware/', 'qrsp/', \
			'camera-devicetree/','devicetree-4.19/', 'audio-devicetree/', 'display-devicetree/', 'video-devicetree/', 'mmrm-devicetree', 'cvp-devicetree', \
			'resource-overlay/', 'interfaces/', 'sectools/', 'techpack/artifacts/camera/', 'qcril-qmi-services-headers/',\
			'sensors-see/USTA/native/power_scripts/'	
			)

platform_whitelist = (
		'resource-overlay/kona/'
	)

whitelist = list()
for item in proprietary_whitelist:
	whitelist.append(psdk_vendor_proprietary + r'/' + item)

# Android.mk under camx/ and chi-cdk/ have a different LOCAL_PATH value
localpath_list = (op.join(psdk_vendor_proprietary, r'chi-cdk/'), op.join(psdk_vendor_proprietary, r'camx/'))
print('--psrc_ap=%s------\n\n'%(psrc_ap))
if args['--copy'] == 'y':
	## 拷贝源码
	if not op.isdir(args['--sdkdir']):
		if os.system('mkdir -p %s'%(psdk)): #创建目录psdk
			print('FAILED to create SDK dir %s'%(psdk))
			sys.exit(1)
	else: # 清空SDK目录下原有内容
		#os.system('rm -rf %s/* %s/.*'%(psdk, psdk)) --wangdq add 这儿会删掉psdk所有文件。小心！！！
		print(psdk_vendor_proprietary)
	for d in os.listdir(psrc_ap): # 拷贝-只需执行一次。后面将其注释，节约时间
		if (d != 'out'):
			if os.system('cp -rf %s/%s %s'%(psrc_ap, d, psdk)):
				print('FAILED to copy %s/%s to %s'%(psrc_ap, d, psdk))

	# 拷贝头文件
	os.system('mkdir -p %s'%(op.join(psdk_complete_qssi_out, r'obj')))
	os.system('mkdir -p %s'%(op.join(psdk_complete_product_out, r'obj')))
	os.system('cp -r %s %s'%(op.join(psrc_qssi_out, r'obj/include'), op.join(psdk_complete_qssi_out, r'obj/')))
	os.system('cp -r %s %s'%(op.join(psrc_product_out, r'obj/include'), op.join(psdk_complete_product_out, r'obj/')))

	# 生成 $(SDK_DIR)/complete_out/Android.mk。除 obj/include 之外的内容将会在cmpcpy时拷贝到complete_out
	#以下路径需要更改，S平台qssi和target是分开编译的，所以这些相对路径都不对。	
	with open(op.join(psdk_complete_product_out, r'../Android.mk'), 'w') as mf:
		s = ('LOCAL_PATH := $(call my-dir)\nPREBUILT_DIR_PATH := $(LOCAL_PATH)\n'
			 '$(shell mkdir $(PRODUCT_OUT)/system $(PRODUCT_OUT)/vendor $(PRODUCT_OUT)/persist $(PRODUCT_OUT)/obj)\n'
			 '$(shell cp -r $(LOCAL_PATH)/' + args['--lunch'] + '/system/* $(PRODUCT_OUT)/system)\n'
			 '$(shell cp -r $(LOCAL_PATH)/' + args['--lunch'] + '/vendor/* $(PRODUCT_OUT)/vendor)\n'
			 '$(shell cp -r $(LOCAL_PATH)/' + args['--lunch'] + '/persist/* $(PRODUCT_OUT)/persist)\n'
			 '$(shell cp -r $(LOCAL_PATH)/' + args['--lunch'] + '/obj/include $(PRODUCT_OUT)/obj)\n'
			 '$(shell mkdir $(PRODUCT_OUT)/../qssi/system $(PRODUCT_OUT)/../qssi/vendor $(PRODUCT_OUT)/../qssi/persist $(PRODUCT_OUT)/../qssi/product $(PRODUCT_OUT)/../qssi/obj)\n'
			 '$(shell cp -r $(LOCAL_PATH)/qssi/system/* $(PRODUCT_OUT)/../qssi/system)\n'
			 '$(shell cp -r $(LOCAL_PATH)/qssi/vendor/* $(PRODUCT_OUT)/../qssi/vendor)\n'
			 '$(shell cp -r $(LOCAL_PATH)/qssi/persist/* $(PRODUCT_OUT)/../qssi/persist)\n'
			 '$(shell cp -r $(LOCAL_PATH)/qssi/product/* $(PRODUCT_OUT)/../qssi/product)\n'
			 '$(shell cp -r $(LOCAL_PATH)/qssi/obj/include $(PRODUCT_OUT)/../qssi/obj)\n')
		mf.write(s)

	# 处理高通私有代码
	#psdk_vendor_proprietary=/home/wangdq/8450/vendor/LA.VENDOR.1.0/LINUX/turbox_sdk/vendor/qcom/proprietary
	print('=======psdk_vendor_proprietary=%s==========\n\n'%(psdk_vendor_proprietary))
	for root, dirs, files in os.walk(psdk_vendor_proprietary): #root 所指的是当前正在遍历的这个文件夹的本身的地址;dirs 是一个 list ，内容是该文件夹中所有的目录的名字(不包括子目录); files同样是 list , 内容是该文件夹中所有的文件(不包括子目录)
		root_path = root + r'/'
		if not root_path.startswith(tuple(whitelist)): #白名单中的目录不遍历
			for f in files:
				if f == 'Android.mk': # wangdq 调试:暂时不解析mk
					
					print('\n\n%s'%(op.join(root, f)))
					if not os.system('resc %s'%(root)): # resc会生成 myAndroid.mk
						if not root_path.startswith(tuple(localpath_list)):
							parseAndroidMK('myAndroid.mk', root)
						else:
							parseAndroidMK('myAndroid.mk', root, True)
						os.system('mv %s/Android.mk %s/Android.mk.bak'%(root, root))
						os.system('mv %s/newAndroid.mk %s/Android.mk'%(root, root))
						os.system('rm %s/myAndroid.mk'%(root))
						# os.system('mv %s/newAndroid.mk %s/Android.mk'%(root, root))
						# os.system('rm %s/myAndroid.mk'%(root))

					else:
						print('resc %s failed'%(op.join(root, f)))
				if f == 'Android.bp': # wangdq 调试mk时:不解析bp
    				#这儿只保留需要编译的module
					
					print('\n\n===parseAndroidBP===\n%s\n'%(op.join(root, f)))
					parseAndroidBP(f, root)
					os.system('mv %s/Android.bp %s/Android.bp.bak'%(root, root))
					os.system('mv %s/newAndroid.bp %s/Android.bp'%(root, root))

	print("+++++++++++++++++++ dulei ++++++++++++++++++++++")
	# 一些Android.mk有例外，不用我们处理，需要恢复
	os.system('cp %s %s'%(op.join(psdk_vendor_proprietary,'commonsys/gps/libs/addon/Android.mk.bak'),\
		op.join(psdk_vendor_proprietary,'commonsys/gps/libs/addon/Android.mk')))
	os.system('cp %s %s'%(op.join(psdk_vendor_proprietary,'data/ipa_fws/Android.mk.bak'),\
		op.join(psdk_vendor_proprietary,'data/ipa_fws/Android.mk')))
	os.system('cp %s %s'%(op.join(psdk_vendor_proprietary,'qcril/qcril_database/Android.mk.bak'),\
		op.join(psdk_vendor_proprietary,'qcril/qcril_database/Android.mk')))
	os.system('cp %s %s'%(op.join(psdk_vendor_proprietary,'qdssagent/Android.mk.bak'),\
		op.join(psdk_vendor_proprietary,'qdssagent/Android.mk')))
	os.system('cp %s %s'%(op.join(psdk_vendor_proprietary,'sensors-see/registry/Android.mk.bak'),\
		op.join(psdk_vendor_proprietary,'sensors-see/registry/Android.mk')))

	print("SRC FILES COPIED")

if args['--cmpcpy'] == 'y':
	print('coming cmpcpy=y')
	# 从源码out目录拷贝SDK缺少的文件(taro)
	for top in (op.join(psrc_product_out, 'system'), op.join(psrc_product_out, 'vendor'), op.join(psrc_product_out, 'persist')):
		for root, dirs, files in os.walk(top):
			for f in files:
				f_in_src = op.join(root, f)
				print('f_in_src=%s\n\n'%(f_in_src))
				f_in_sdk = f_in_src.replace(psrc_product_out, psdk_product_out)
				if op.islink(f_in_src):
					continue
				if not op.exists(f_in_sdk):
					dir_in_complete_out = root.replace(psrc_product_out, psdk_complete_product_out)
					if not op.isdir(dir_in_complete_out):
						os.makedirs(dir_in_complete_out)
					os.system('cp %s %s'%(f_in_src, dir_in_complete_out))

	# 从源码out目录拷贝SDK缺少的文件(qssi)
	for top in (op.join(psrc_qssi_out, 'system'), op.join(psrc_qssi_out, 'vendor'),\
		op.join(psrc_qssi_out, 'persist'), op.join(psrc_qssi_out, 'product')):
		for root, dirs, files in os.walk(top):
			for f in files:
				f_in_src = op.join(root, f)
				print('f_in_src=%s\n\n'%(f_in_src))
				f_in_sdk = f_in_src.replace(psrc_qssi_out, psdk_qssi_out) #把字符串中的old字符串替换成new新字符串 str.replace(old, new)
				print('f_in_sdk=%s\n\n'%(f_in_sdk))
				if op.islink(f_in_src):
					continue
				if not op.exists(f_in_sdk):
					dir_in_complete_out = root.replace(psrc_qssi_out, psdk_complete_qssi_out)
					if not op.isdir(dir_in_complete_out):
						os.makedirs(dir_in_complete_out)
					os.system('cp %s %s'%(f_in_src, dir_in_complete_out))
